## opencolorio 1.1.1~dfsg0

=== CMakeLists.txt ===
project(OpenColorIO)
set(OCIO_VERSION_MAJOR 1)
set(OCIO_VERSION_MINOR 1)
set(OCIO_VERSION_PATCH 1)

cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/share/cmake)
if(NOT DEFINED CMAKE_FIRST_RUN)
    SET(CMAKE_FIRST_RUN 1 CACHE INTERNAL "")
endif()

###############################################################################
### GLOBAL ###

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
option(OCIO_BUILD_SHARED "Set to OFF to disable building the shared core library" ON)
option(OCIO_BUILD_STATIC "Set to OFF to disable building the static core library" ON)
option(OCIO_BUILD_TRUELIGHT "Set to OFF to disable truelight" ON)
option(OCIO_BUILD_APPS "Set to OFF to disable command-line apps" ON)
option(OCIO_BUILD_NUKE "Set to OFF to disable building nuke plugins" ON)
option(OCIO_BUILD_DOCS "Specify whether to build documentation" UNIX)
option(OCIO_BUILD_TESTS "Specify whether to build unittests" ON)
option(OCIO_BUILD_PYGLUE "Specify whether to build python bindings" ON)
option(OCIO_BUILD_JNIGLUE "Specify whether to build java bindings" OFF)
option(OCIO_STATIC_JNIGLUE "Specify whether to statically link ocio to the java bindings" ON)

option(OCIO_USE_SSE "Specify whether to enable SSE CPU performance optimizations" ON)
option(OCIO_INLINES_HIDDEN "Specify whether to build with -fvisibility-inlines-hidden" UNIX)

# Use boost's shared_ptr by default on Windows (as <VS2010 doesn't have it),
# Use std::tr1::shared_ptr by default on other platforms
option(OCIO_USE_BOOST_PTR "Set to ON to enable boost shared_ptr (necessary when tr1 is not available)" WIN32)

option(OCIO_PYGLUE_LINK "If ON, link the Python module to the core shared library" OFF)
option(OCIO_PYGLUE_RESPECT_ABI "If ON, the Python module install path includes Python UCS version" OFF)
option(OCIO_PYGLUE_SONAME "If ON, soname/soversion will be set for Python module library" OFF)
option(OCIO_PYGLUE_LIB_PREFIX "If ON, prefix the Python module with 'lib'" OFF)

if(UNIX AND NOT APPLE)
    option(USE_EXTERNAL_YAML "Use system installed yaml-cpp library." OFF)
    option(USE_EXTERNAL_TINYXML "Use system installed tinyxml library." OFF)
    option(USE_EXTERNAL_LCMS "Use system install lcms2 library." OFF)
endif()

# This does not include the SOVERSION override, on purpose, so that the
# OCIO_VERSION value will be an accurate reflection of the underlying library version.
set(OCIO_VERSION "${OCIO_VERSION_MAJOR}.${OCIO_VERSION_MINOR}.${OCIO_VERSION_PATCH}")

if(NOT SOVERSION)
    set(SOVERSION ${OCIO_VERSION_MAJOR} CACHE STRING "Set the SO version in the SO name of the output library")
endif()

###############################################################################
if(POLICY CMP0054)
    ## Only interpret if() arguments as variables or keywords when unquoted
    cmake_policy(SET CMP0054 NEW)
endif()

include(ParseArguments)
include(OCIOMacros)
include(ExternalProject)

enable_language(CXX)

ENABLE_TESTING()

if(APPLE OR IPHONE)
    if(NOT CMAKE_OSX_ARCHITECTURES)
        set(CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING
            "Setting OSX Architectures, options are: ppc;i386;ppc64;x86_64"
            FORCE)
    endif()
    if(CMAKE_FIRST_RUN)
        message(STATUS "Setting OSX Architectures to: ${CMAKE_OSX_ARCHITECTURES}")
    endif()
endif()

# Set the default built type
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)
if(CMAKE_FIRST_RUN)
    message(STATUS "Setting Build Type to: ${CMAKE_BUILD_TYPE}")
endif()

# Set the default namespace
if(NOT OCIO_NAMESPACE)
  set(OCIO_NAMESPACE OpenColorIO CACHE STRING
      "Specify the master OCIO C++ namespace: Options include OpenColorIO OpenColorIO_<YOURFACILITY> etc."
      FORCE)
endif(NOT OCIO_NAMESPACE)
messageonce("Setting Namespace to: ${OCIO_NAMESPACE}")

# If CMAKE_INSTALL_EXEC_PREFIX is not specified, install binaries
# directly into the regular install prefix
if(NOT CMAKE_INSTALL_EXEC_PREFIX)
    messageonce("Exec prefix not specified, defaulting to ${CMAKE_INSTALL_PREFIX}")
    set(CMAKE_INSTALL_EXEC_PREFIX ${CMAKE_INSTALL_PREFIX})
endif()

messageonce("Use Boost Ptr: ${OCIO_USE_BOOST_PTR}")
if(OCIO_USE_BOOST_PTR)
    set(Boost_ADDITIONAL_VERSIONS "1.49" "1.45" "1.44" "1.43" "1.43.0" "1.42"
                                  "1.42.0" "1.41" "1.41.0" "1.40"
                                  "1.40.0" "1.39" "1.39.0" "1.38"
                                  "1.38.0" "1.37" "1.37.0" "1.34.1"
                                  "1_34_1")
    set(Boost_USE_MULTITHREADED ON)
    find_package(Boost 1.34)
    if(NOT Boost_FOUND)
        message(FATAL_ERROR "OCIO_USE_BOOST_PTR is specified, but a boost installation could not be found.")
    else()
        set(OCIO_USE_BOOST_PTR 1)
    endif()

    set(EXTERNAL_INCLUDE_DIRS ${EXTERNAL_INCLUDE_DIRS} ${Boost_INCLUDE_DIR})
    # set(EXTERNAL_LIBRARIES ${EXTERNAL_LIBRARIES} ${Boost_LIB_DIAGNOSTIC_DEFINITIONS})
else()
    set(OCIO_USE_BOOST_PTR 0)
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    if(OCIO_INLINES_HIDDEN)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                        OUTPUT_VARIABLE GCC_VERSION)
        if (GCC_VERSION VERSION_LESS 4.2)
            message(STATUS "WARNING: GCC Version < 4.2 - disabling hidden inlines")
            set(OCIO_INLINES_HIDDEN OFF)
        endif()
    endif()
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    # Enable a bunch of compiler warnings...
    # http://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wshadow -Wconversion -Wcast-qual -Wformat=2")
    # set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
endif(CMAKE_COMPILER_IS_GNUCXX)

###############################################################################
### Python ###

OCIOFindPython()

# Find Python, used for (possibly) building pyglue, and now to
# construct the external project path
set(EXTDIST_ROOT ${CMAKE_BINARY_DIR}/ext/dist)
set(EXTDIST_BINPATH ${EXTDIST_ROOT}/bin)
if(PYTHON_OK)
    set(EXTDIST_PYTHONPATH ${EXTDIST_ROOT}/${PYTHON_VARIANT_PATH})
    if(UNIX)
        set(PYTHONPATH ${EXTDIST_PYTHONPATH}:$ENV{PYTHONPATH})
    else()
        # The line below should work but ';' is always replaced by a space
        #   which breaks the build. Anyway in the worst scenario, no expected
        #   modules are present in the local python so install them.
        #set(PYTHONPATH ${EXTDIST_PYTHONPATH}\\;$ENV{PYTHONPATH})
        set(PYTHONPATH ${EXTDIST_PYTHONPATH})
    endif()
endif()

messageonce("Setting EXTDIST_BINPATH: ${EXTDIST_BINPATH}")
messageonce("Setting EXTDIST_PYTHONPATH: ${EXTDIST_PYTHONPATH}")

###############################################################################
### tinyxml ###
##TODO: yaml and tinyxml : when there are not USE_EXTERNAL_TINYXML, use the same cmake schema/instructions => maybe refactorize in a cmake functions/macros ?

if(USE_EXTERNAL_TINYXML)
    set(TINYXML_VERSION_MIN "2.6.1")
    find_package(TinyXML)
    if(TINYXML_FOUND)
        if(TINYXML_VERSION VERSION_EQUAL ${TINYXML_VERSION_MIN} OR
           TINYXML_VERSION VERSION_GREATER ${TINYXML_VERSION_MIN})
            message(STATUS "External TinyXML will be used.")
        else()
            message(FATAL_ERROR "ERROR: ${TINYXML_VERSION} found, but ${TINYXML_VERSION_MIN} or newer is required.")
        endif()
    else(TINYXML_FOUND)
        message(STATUS "TinyXML was not found. Perhaps you forgot to install the development package?")
    endif(TINYXML_FOUND)

else(USE_EXTERNAL_TINYXML)
    set(TINYXML_VERSION 2_6_1)
    set(TINYXML_CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}/ext/dist -DOCIO_INLINES_HIDDEN:BOOL=${OCIO_INLINES_HIDDEN})
    if(CMAKE_TOOLCHAIN_FILE)
        set(TINYXML_CMAKE_ARGS ${TINYXML_CMAKE_ARGS} -DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE})
    endif()
    set(TINYXML_CMAKE_ARGS ${TINYXML_CMAKE_ARGS} -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
    set(TINYXML_ZIPFILE     "${CMAKE_SOURCE_DIR}/ext/tinyxml_${TINYXML_VERSION}.tar.gz")
    set(TINYXML_PATCHFILE   "${CMAKE_SOURCE_DIR}/ext/tinyxml_${TINYXML_VERSION}.patch")
    set(TINYXML_SOURCE_DIR  "${CMAKE_BINARY_DIR}/ext")
    ## Create our TINYXML_LIB target
    if(CMAKE_VERSION VERSION_GREATER "2.8.7")
        option(TINYXML_OBJECT_LIB_EMBEDDED ${OCIO_BUILD_STATIC} "directly embedded tinyxml 3rdParty object lib into our resulting static lib, no link needed anymore")
    else()
        set(TINYXML_OBJECT_LIB_EMBEDDED OFF CACHE BOOL "directly embedded tinyxml 3rdParty object lib into our resulting static lib, no link needed anymore" FORCE)
        message("Force disable TINYXML_OBJECT_LIB_EMBEDDED feature due to CMake Version less than 2.8.8")
    endif()
    mark_as_advanced(TINYXML_OBJECT_LIB_EMBEDDED) ## two way to build with tinyxml (objects embedded or static transitive link)
    if(TINYXML_OBJECT_LIB_EMBEDDED)
        set(tinyxml_sources ${TINYXML_SOURCE_DIR}/tinyxml/tinystr.cpp       ${TINYXML_SOURCE_DIR}/tinyxml/tinyxml.cpp 
                            ${TINYXML_SOURCE_DIR}/tinyxml/tinyxmlerror.cpp  ${TINYXML_SOURCE_DIR}/tinyxml/tinyxmlparser.cpp )
        set(tinyxml_headers ${TINYXML_SOURCE_DIR}/tinyxml/tinystr.h         ${TINYXML_SOURCE_DIR}/tinyxml/tinyxml.h )
        add_custom_command(                                 ## will be done at build time
            OUTPUT ${tinyxml_sources} ${tinyxml_headers}    ## expected output files
            COMMAND ${CMAKE_COMMAND} -E tar xzf ${TINYXML_ZIPFILE}
            DEPENDS ${TINYXML_ZIPFILE}
            WORKING_DIRECTORY ${TINYXML_SOURCE_DIR}
            COMMENT "Unpacking ${TINYXML_ZIPFILE} to ${TINYXML_SOURCE_DIR}"
            VERBATIM
        )
        include_directories(BEFORE ${TINYXML_SOURCE_DIR}/tinyxml) ## needed to build correctly
        add_library(TINYXML_LIB OBJECT ${tinyxml_sources})
        ## embedded tinyxml objects files (no static link needed anymore) 
        ## => great news when build staticaly since we do not want another client project have to link also with tinyxml when he want to use this project
        ## => could be problematic if the client project use another version of tinyxml... In this case build tinyxml as shared lib with all projects could be a solution
        ## => TODO: so maybe provide a simple cmake way to build 3rdParty as shared and auto install with this project ?
        set_target_properties(TINYXML_LIB PROPERTIES COMPILE_FLAGS "-DTIXML_USE_STL -fPIC -fvisibility-inlines-hidden -fvisibility=hidden")
        add_definitions(-DTIXML_USE_STL) ## needed to build correctly, and also need to be propagated in child projects (client projects)
        list(APPEND EXTERNAL_OBJECTS $<TARGET_OBJECTS:TINYXML_LIB>)
    else()
        find_package(Git REQUIRED) ## in order to apply patch (for crossplateform compatibility)
        ExternalProject_Add(tinyxml
            URL             ${TINYXML_ZIPFILE}
            SOURCE_DIR      ${TINYXML_SOURCE_DIR}/tinyxml
            PATCH_COMMAND   ${GIT_EXECUTABLE} apply --ignore-whitespace ${TINYXML_PATCHFILE}
            BINARY_DIR      ext/build/tinyxml
            INSTALL_DIR     ext/dist
            CMAKE_ARGS      ${TINYXML_CMAKE_ARGS}
        )
        if(WIN32)
            set(TINYXML_STATIC_LIBRARIES  ${PROJECT_BINARY_DIR}/ext/dist/lib/tinyxml.lib)
        else()
            set(TINYXML_STATIC_LIBRARIES ${PROJECT_BINARY_DIR}/ext/dist/lib/libtinyxml.a)
        endif()
        add_library(TINYXML_LIB STATIC IMPORTED)
        ## static is the .lib location, shared is the .dll/.so location (see IMPORTED_IMPLIB for the associated .lib archive location on windows)
        set_property(TARGET TINYXML_LIB PROPERTY IMPORTED_LOCATION ${TINYXML_STATIC_LIBRARIES})
        add_dependencies(TINYXML_LIB tinyxml)
        list(APPEND EXTERNAL_LIBRARIES TINYXML_LIB)
    endif()
    set_target_properties(TINYXML_LIB PROPERTIES FOLDER External)

=== docs/CMakeLists.txt ===

###############################################################################
### External Doc Apps ###

if (WIN32)
    # Workaround to mimic *nix '> PYTHONPATH=XXX CMD' 
    #  on windows, it becomes  '> set PYTHONPATH=XXX \n call CMD'
    #   '\n' is here because '\\&' does not work.
    set(PYT_PRE_CMD set PYTHONPATH=${PYTHONPATH} "\n" call )
    # Unfortunately some windows tools require to have
    #  the paths with the '\' (not working with '//').
    set(PYT_LIB_OUTPUT ${EXTDIST_ROOT})
    string(REGEX REPLACE "/" "\\\\" PYT_LIB_OUTPUT ${PYT_LIB_OUTPUT})
    set(PYT_EXTDIST_BINPATH ${EXTDIST_BINPATH})
    string(REGEX REPLACE "/" "\\\\" PYT_EXTDIST_BINPATH ${PYT_EXTDIST_BINPATH})
else()
    set(PYT_PRE_CMD PYTHONPATH=${PYTHONPATH})
    set(PYT_LIB_OUTPUT ${EXTDIST_ROOT})
    set(PYT_EXTDIST_BINPATH ${EXTDIST_BINPATH})
endif()

# setuptools
# https://pypi.python.org/pypi/setuptools
set(SETUPTOOLS_VERSION 1.1.6)

ExternalProject_Add(setuptools
    URL ${CMAKE_SOURCE_DIR}/ext/setuptools-${SETUPTOOLS_VERSION}.tar.gz
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ${CMAKE_COMMAND} -E make_directory ${EXTDIST_PYTHONPATH}
    BUILD_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py build
    INSTALL_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py install --prefix=${PYT_LIB_OUTPUT}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/setuptools-prefix/src/setuptools
)

# docutils
# https://pypi.python.org/pypi/docutils
set(DOCUTILS_VERSION 0.11)
ExternalProject_Add(docutils
    DEPENDS setuptools
    URL ${CMAKE_SOURCE_DIR}/ext/docutils-${DOCUTILS_VERSION}.tar.gz
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ${CMAKE_COMMAND} -E make_directory ${EXTDIST_PYTHONPATH}
    BUILD_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py build
    INSTALL_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py install --prefix=${PYT_LIB_OUTPUT}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docutils-prefix/src/docutils
)

# jinja2
# https://pypi.python.org/pypi/Jinja2
set(JINJA2_VERSION 2.7.1)
ExternalProject_Add(Jinja2
    DEPENDS setuptools
    URL ${CMAKE_SOURCE_DIR}/ext/Jinja2-${JINJA2_VERSION}.tar.gz
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ${CMAKE_COMMAND} -E make_directory ${EXTDIST_PYTHONPATH}
    BUILD_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py build
    INSTALL_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py install --prefix=${PYT_LIB_OUTPUT}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Jinja2-prefix/src/Jinja2
)

# Pygments
# https://pypi.python.org/pypi/Pygments
set(PYGMENTS_VERSION 1.6)
ExternalProject_Add(Pygments
    DEPENDS setuptools
    URL ${CMAKE_SOURCE_DIR}/ext/Pygments-${PYGMENTS_VERSION}.tar.gz
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ${CMAKE_COMMAND} -E make_directory ${EXTDIST_PYTHONPATH}
    BUILD_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py build
    INSTALL_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py install --prefix=${PYT_LIB_OUTPUT}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Pygments-prefix/src/Pygments
)

# sphinx
# https://pypi.python.org/pypi/Sphinx
set(SPHINX_VERSION 1.2b3)
ExternalProject_Add(Sphinx
    DEPENDS setuptools docutils Jinja2 Pygments
    URL ${CMAKE_SOURCE_DIR}/ext/Sphinx-${SPHINX_VERSION}.tar.gz
    PATCH_COMMAND patch -p1 < ${CMAKE_SOURCE_DIR}/ext/Sphinx-${SPHINX_VERSION}.patch
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ${CMAKE_COMMAND} -E make_directory ${EXTDIST_PYTHONPATH}
    BUILD_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py build
    INSTALL_COMMAND ${PYT_PRE_CMD} ${PYTHON} setup.py install --prefix=${PYT_LIB_OUTPUT} --install-scripts=${PYT_EXTDIST_BINPATH}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Sphinx-prefix/src/Sphinx
)

###############################################################################
### Create Doc Targets ###

message(STATUS "Create sphinx conf.py from conf.py.in")
configure_file(${CMAKE_SOURCE_DIR}/docs/conf.py.in
    ${CMAKE_BINARY_DIR}/docs/conf.py @ONLY)

message(STATUS "Copying doc to staging area")
file(
    COPY ${CMAKE_SOURCE_DIR}/docs/
    DESTINATION ${CMAKE_BINARY_DIR}/docs

    # Ignore dot files like emacs' temporary .#somefile.rst which
    # break Sphinx (and must be manually removed from the destination)
    PATTERN ".*" EXCLUDE
    )

message(STATUS "Copy extra doc files to staging area")
list(APPEND DOCFILES ${CMAKE_SOURCE_DIR}/README.md)
list(APPEND DOCFILES ${CMAKE_SOURCE_DIR}/INSTALL)
list(APPEND DOCFILES ${CMAKE_SOURCE_DIR}/ChangeLog)
list(APPEND DOCFILES ${CMAKE_SOURCE_DIR}/LICENSE)
list(APPEND DOCFILES ${CMAKE_SOURCE_DIR}/share/nuke/ocionuke/viewer.py)
CopyFiles(RSTDOC ${DOCFILES})

message(STATUS "Extracting .rst files from C++ headers")
ExtractRstCPP(${CMAKE_SOURCE_DIR}/export/OpenColorIO/OpenColorIO.h ${CMAKE_BINARY_DIR}/docs/developers/api/OpenColorIO.rst)
ExtractRstCPP(${CMAKE_SOURCE_DIR}/export/OpenColorIO/OpenColorTransforms.h ${CMAKE_BINARY_DIR}/docs/developers/api/OpenColorTransforms.rst)
ExtractRstCPP(${CMAKE_SOURCE_DIR}/export/OpenColorIO/OpenColorTypes.h ${CMAKE_BINARY_DIR}/docs/developers/api/OpenColorTypes.rst)

if(OCIO_BUILD_PYGLUE)
    set(DEPLIBS OpenColorIO PyOpenColorIO)
else()
    set(DEPLIBS OpenColorIO)
endif()

add_custom_target(doc ALL
    COMMAND ${PYT_PRE_CMD} ${EXTDIST_BINPATH}/sphinx-build -b html . ${CMAKE_CURRENT_BINARY_DIR}/build-html
    DEPENDS
        ${DEPLIBS}
        ${CMAKE_BINARY_DIR}/docs/conf.py
        developers/api/OpenColorIO.rst
        developers/api/OpenColorTransforms.rst
        developers/api/OpenColorTypes.rst
        ${RSTDOC_OUTPUT}
    COMMENT "Building html docs"
    SOURCES ${DOCFILES})

# note: ExternalProject will not build when added to a add_custom_target this
# works around this problem. This seems to be fixed in the cmake ^HEAD
add_dependencies(doc Sphinx) 

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build-html/
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/OpenColorIO/html
        PATTERN .* EXCLUDE
)

find_package(LATEX)
if(PDFLATEX_COMPILER)
    
    add_custom_target(latex
        COMMAND ${PYT_PRE_CMD} ${EXTDIST_BINPATH}/sphinx-build -b latex . ${CMAKE_CURRENT_BINARY_DIR}/build-latex
        DEPENDS
            OpenColorIO
            ${CMAKE_BINARY_DIR}/docs/conf.py
            developers/api/OpenColorIO.rst
            developers/api/OpenColorTransforms.rst
            developers/api/OpenColorTypes.rst
            ${RSTDOC_OUTPUT}
        COMMENT "Building latex doc"
        SOURCES ${DOCFILES})
    add_dependencies(latex Sphinx)
    
    add_custom_target(pdf ALL
        COMMAND ${PDFLATEX_COMPILER} OpenColorIO.tex
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build-latex
        COMMENT "Building pdf doc"
        SOURCES ${DOCFILES})
    add_dependencies(pdf latex)
    
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/build-latex/OpenColorIO.pdf
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/OpenColorIO/)
    
endif()

=== src/core_tests/CMakeLists.txt ===
###############################################################################
### CORE UNIT TESTS ###

add_definitions("-DOCIO_UNIT_TEST")
add_definitions("-DOCIO_SOURCE_DIR=${CMAKE_SOURCE_DIR}")

include_directories(
    ${CMAKE_SOURCE_DIR}/export/
    ${CMAKE_BINARY_DIR}/export/
    ${CMAKE_SOURCE_DIR}/ext/oiio/src/include
    ${EXTERNAL_INCLUDE_DIRS}
    )

if(WIN32)
    # Hack to get around the "Debug" and "Release" sub directories 
    #  cmake tries to add with Windows VC+++ IDE

    # Set output path
    set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
    set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
    set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
    # For multi-config builds (e.g. msvc)
    foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
        string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
        set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_CURRENT_BINARY_DIR} )
        set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_CURRENT_BINARY_DIR} )
        set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_CURRENT_BINARY_DIR} )
    endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )
endif()


## do not link with OpenColorIO since we reuse the sources files to build this app (avoid double link definition)
file( GLOB_RECURSE core_test_src_files "${CMAKE_SOURCE_DIR}/src/core/*.cpp" )
add_executable(ocio_core_tests ${EXTERNAL_OBJECTS} ${core_test_src_files})

set_target_properties(ocio_core_tests PROPERTIES COMPILE_FLAGS -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})

if(USE_EXTERNAL_TINYXML)
    target_link_libraries(ocio_core_tests ${TINYXML_LIBRARIES})
else(USE_EXTERNAL_TINYXML)
    add_dependencies(ocio_core_tests TINYXML_LIB)
endif(USE_EXTERNAL_TINYXML)

if(USE_EXTERNAL_YAML)
    target_link_libraries(ocio_core_tests ${YAML_CPP_LIBRARIES})
else(USE_EXTERNAL_YAML)
    add_dependencies(ocio_core_tests YAML_CPP_LIB)
endif(USE_EXTERNAL_YAML)

if(EXTERNAL_LIBRARIES)
    target_link_libraries(ocio_core_tests ${EXTERNAL_LIBRARIES})
endif()

set_target_properties(ocio_core_tests PROPERTIES
    COMPILE_FLAGS       "${EXTERNAL_COMPILE_FLAGS}"
    LINK_FLAGS          "${EXTERNAL_LINK_FLAGS}"
    ## to avoid import/export link dll incoherences (since we build an app with OpenColorIO sources)
    COMPILE_DEFINITIONS OpenColorIO_STATIC
)

###############################################################################
### CTEST ###

set(OCIO_TEST_AREA ${CMAKE_CURRENT_BINARY_DIR})

if(UNIX)
    message(STATUS "Create ocio_core_tests.sh.in from ocio_core_tests.sh")

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ocio_core_tests.sh.in
        ${CMAKE_CURRENT_BINARY_DIR}/ocio_core_tests.sh @ONLY)

    add_custom_target(MainTests
                      COMMAND /bin/sh ${CMAKE_CURRENT_BINARY_DIR}/ocio_core_tests.sh
                      DEPENDS ocio_core_tests
                      COMMENT "Setting Up and Running OCIO UNIT tests")
else()
    message(STATUS "Create ocio_core_tests.bat.in from ocio_core_tests.bat")

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ocio_core_tests.bat.in
        ${CMAKE_CURRENT_BINARY_DIR}/ocio_core_tests.bat @ONLY)

    add_custom_target(MainTests
                      COMMAND ${CMAKE_CURRENT_BINARY_DIR}/ocio_core_tests.bat
                      DEPENDS ocio_core_tests
                      COMMENT "Setting Up and Running OCIO UNIT tests")
endif()

add_test(ocio_core_tests "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target MainTests)

=== src/jniglue/CMakeLists.txt ===

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/export/
  ${CMAKE_BINARY_DIR}/export/
  ${JNI_INCLUDE_DIRS}
)

set(JNIOCIO_CLASSES
  # Core
  org.OpenColorIO.ExceptionBase
  org.OpenColorIO.ExceptionMissingFile
  org.OpenColorIO.Globals
  org.OpenColorIO.Config
  org.OpenColorIO.ColorSpace
  org.OpenColorIO.Processor
  org.OpenColorIO.GpuShaderDesc
  org.OpenColorIO.Context
  org.OpenColorIO.Look
  org.OpenColorIO.ImageDesc
  org.OpenColorIO.Transform
  org.OpenColorIO.PackedImageDesc
  org.OpenColorIO.PlanarImageDesc
  org.OpenColorIO.Baker
  # Enums
  org.OpenColorIO.LoggingLevel
  org.OpenColorIO.ColorSpaceDirection
  org.OpenColorIO.TransformDirection
  org.OpenColorIO.Interpolation
  org.OpenColorIO.BitDepth
  org.OpenColorIO.Allocation
  org.OpenColorIO.GpuLanguage
  org.OpenColorIO.EnvironmentMode
  # Transforms
  org.OpenColorIO.AllocationTransform
  org.OpenColorIO.CDLTransform
  org.OpenColorIO.ColorSpaceTransform
  org.OpenColorIO.DisplayTransform
  org.OpenColorIO.ExponentTransform
  org.OpenColorIO.FileTransform
  org.OpenColorIO.GroupTransform
  org.OpenColorIO.LogTransform
  org.OpenColorIO.LookTransform
  org.OpenColorIO.MatrixTransform
  org.OpenColorIO.TruelightTransform
)

file(GLOB JNIOCIO_JAVAS "org/OpenColorIO/*.java")

message(STATUS "Creating Jar Manifest.txt")
configure_file(${CMAKE_SOURCE_DIR}/src/jniglue/Manifest.txt.in
    ${CMAKE_CURRENT_BINARY_DIR}/Manifest.txt @ONLY)

message(STATUS "Creating LoadLibrary.java")
configure_file(${CMAKE_SOURCE_DIR}/src/jniglue/LoadLibrary.java.in
    ${CMAKE_CURRENT_BINARY_DIR}/LoadLibrary.java @ONLY)
list(APPEND JNIOCIO_JAVAS ${CMAKE_CURRENT_BINARY_DIR}/LoadLibrary.java)

set(JNIOCIO_HEADERS)
set(JNIOCIO_H_INCLUDE "/* DO NOT EDIT THIS FILE - it is machine generated */\n\n")
foreach(_CLASS ${JNIOCIO_CLASSES})
  string(REPLACE "." "_" _CLASS_H ${_CLASS})
  set(_CLASS_H "${_CLASS_H}.h")
  set(JNIOCIO_HEADERS ${JNIOCIO_HEADERS} "${_CLASS_H}")
  set(JNIOCIO_H_INCLUDE "${JNIOCIO_H_INCLUDE}#include \"${_CLASS_H}\"\n")
endforeach()
message(STATUS "Creating OpenColorIOJNI.h that includes all the ocio jni headers")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/OpenColorIOJNI.h" "${JNIOCIO_H_INCLUDE}")

set(JNIOCIO_JAR "${CMAKE_CURRENT_BINARY_DIR}/OpenColorIO-${OCIO_VERSION}.jar")
add_custom_command(OUTPUT ${JNIOCIO_HEADERS}
                   COMMAND cmake -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/org/OpenColorIO
                   COMMAND ${Java_JAVAC_EXECUTABLE} -cp ${CMAKE_CURRENT_BINARY_DIR} -d ${CMAKE_CURRENT_BINARY_DIR} ${JNIOCIO_JAVAS}
                   COMMAND ${Java_JAVAH_EXECUTABLE} -jni -force ${JNIOCIO_CLASSES}
                   COMMAND ${Java_JAR_EXECUTABLE} vcfm ${JNIOCIO_JAR} Manifest.txt org
                   IMPLICIT_DEPENDS ${JNIOCIO_JAVAS}
                   COMMENT "Compiling .java files, packaged .jar and creating jni C headers")

file(GLOB JNIOCIO_SRC "*.cpp")
add_library(OpenColorIO-JNI SHARED ${JNIOCIO_SRC} ${JNIOCIO_HEADERS})
set_target_properties(OpenColorIO-JNI PROPERTIES
                      VERSION ${OCIO_VERSION}
                      SOVERSION ${SOVERSION})
if(OCIO_STATIC_JNIGLUE)
  target_link_libraries(OpenColorIO-JNI OpenColorIO_STATIC)
else()
  target_link_libraries(OpenColorIO-JNI OpenColorIO)
endif()

add_subdirectory(tests)

install(TARGETS OpenColorIO-JNI EXPORT OpenColorIO DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/lib${LIB_SUFFIX})
install(FILES ${JNIOCIO_JAR} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/ocio/)

=== src/nuke/CMakeLists.txt ===
if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -undefined dynamic_lookup")
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/export/
    ${CMAKE_BINARY_DIR}/export/
    ${Nuke_INCLUDE_DIR}
)

###############################################################################
### NukeOCIOColorSpace ###

add_library(NukeOCIOColorSpace MODULE
    OCIOColorSpace/OCIOColorSpace.cpp
)
target_link_OCIO(NukeOCIOColorSpace #${Nuke_LIBRARIES}
)
set_target_properties(NukeOCIOColorSpace
    PROPERTIES
    PREFIX ""
    OUTPUT_NAME "OCIOColorSpace"
)

###############################################################################
### NukeOCIODisplay ###

add_library(NukeOCIODisplay MODULE
    OCIODisplay/OCIODisplay.cpp
)
target_link_OCIO(NukeOCIODisplay #${Nuke_LIBRARIES}
)
set_target_properties(NukeOCIODisplay
    PROPERTIES
    PREFIX ""
    OUTPUT_NAME "OCIODisplay"
)

###############################################################################
### NukeOCIOFileTransform ###

add_library(NukeOCIOFileTransform MODULE
    OCIOFileTransform/OCIOFileTransform.cpp
)
target_link_OCIO(NukeOCIOFileTransform #${Nuke_LIBRARIES}
)
set_target_properties(NukeOCIOFileTransform
    PROPERTIES
    PREFIX ""
    OUTPUT_NAME "OCIOFileTransform"
)

###############################################################################
### NukeOCIOLogConvert ###

add_library(NukeOCIOLogConvert MODULE
    OCIOLogConvert/OCIOLogConvert.cpp
)
target_link_OCIO(NukeOCIOLogConvert #${Nuke_LIBRARIES}
)
set_target_properties(NukeOCIOLogConvert
    PROPERTIES
    PREFIX ""
    OUTPUT_NAME "OCIOLogConvert"
)

###############################################################################
### NukeOCIOLookTransform ###

add_library(NukeOCIOLookTransform MODULE
    OCIOLookTransform/OCIOLookTransform.cpp
)
target_link_OCIO(NukeOCIOLookTransform #${Nuke_LIBRARIES}
)
set_target_properties(NukeOCIOLookTransform
    PROPERTIES
    PREFIX ""
    OUTPUT_NAME "OCIOLookTransform"
)

###############################################################################
### NukeOCIOCDLTransform ###

add_library(NukeOCIOCDLTransform MODULE
    OCIOCDLTransform/OCIOCDLTransform.cpp
)
target_link_OCIO(NukeOCIOCDLTransform #${Nuke_LIBRARIES}
)
set_target_properties(NukeOCIOCDLTransform
    PROPERTIES
    PREFIX ""
    OUTPUT_NAME "OCIOCDLTransform"
)

###############################################################################
### Nuke Targets ###

add_custom_target(Nuke
    DEPENDS NukeOCIOColorSpace
    DEPENDS NukeOCIODisplay
    DEPENDS NukeOCIOFileTransform
    DEPENDS NukeOCIOLogConvert
    DEPENDS NukeOCIOCDLTransform
)

install(TARGETS NukeOCIOColorSpace EXPORT OpenColorIO 
        DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/lib/nuke${Nuke_API_VERSION})

install(TARGETS NukeOCIODisplay EXPORT OpenColorIO 
        DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/lib/nuke${Nuke_API_VERSION})

install(TARGETS NukeOCIOLogConvert EXPORT OpenColorIO 
        DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/lib/nuke${Nuke_API_VERSION})

install(TARGETS NukeOCIOFileTransform EXPORT OpenColorIO 
        DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/lib/nuke${Nuke_API_VERSION})

install(TARGETS NukeOCIOLookTransform EXPORT OpenColorIO 
        DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/lib/nuke${Nuke_API_VERSION})

install(TARGETS NukeOCIOCDLTransform EXPORT OpenColorIO 
        DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/lib/nuke${Nuke_API_VERSION})

install(DIRECTORY ${CMAKE_SOURCE_DIR}/share/nuke
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/
        PATTERN .svn EXCLUDE)

=== src/pyglue/CMakeLists.txt ===
if(CMAKE_FIRST_RUN)
    message(STATUS "Python library to include 'lib' prefix: ${OCIO_PYGLUE_LIB_PREFIX}")
endif()


if(CMAKE_FIRST_RUN)
    message(STATUS "Python ${PYTHON_VERSION} okay (UCS: ${PYTHON_UCS}), will build the Python bindings against ${PYTHON_INCLUDE}")
    message(STATUS "Python variant path is ${PYTHON_VARIANT_PATH}")
endif()
    
if(CMAKE_COMPILER_IS_GNUCXX)
    # Python breaks strict-aliasing rules. Disable the warning here.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-strict-aliasing -Wno-missing-field-initializers")
endif()

if(WIN32)
    # Mute a design issue where the Exception public class inherits 
    # from a STL Exception. STL classes are never supposed to
    # be exported among different dynamic libraries.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4275")
endif()

# Process all warnings as errors
# Unfortunately Windows still has a warning
if(UNIX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

find_package(PythonLibs)
if(NOT PYTHONLIBS_FOUND)
    message(FATAL "Python libraries were not found, exiting.")
endif()
SET(PYTHON_INCLUDES ${PYTHON_INCLUDE_DIRS})

add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/src/pyglue/PyDoc.h
                  COMMAND ${PYTHON} ${CMAKE_SOURCE_DIR}/src/pyglue/createPyDocH.py ${CMAKE_BINARY_DIR}/src/pyglue/PyDoc.h
                  COMMENT "Creating PyDoc.h")

file( GLOB pyglue_src_files "${CMAKE_SOURCE_DIR}/src/pyglue/*.cpp" )

add_library(PyOpenColorIO MODULE ${pyglue_src_files} ${CMAKE_BINARY_DIR}/src/pyglue/PyDoc.h)

add_definitions(-DPYOCIO_NAME=PyOpenColorIO)

if(OCIO_USE_BOOST_PTR)
    include_directories(
        ${CMAKE_SOURCE_DIR}/export/
        ${CMAKE_BINARY_DIR}/export/
        ${CMAKE_CURRENT_BINARY_DIR}
        ${PYTHON_INCLUDE}
        ${Boost_INCLUDE_DIR}
    )
else()
    include_directories(
        ${CMAKE_SOURCE_DIR}/export/
        ${CMAKE_BINARY_DIR}/export/
        ${CMAKE_CURRENT_BINARY_DIR}
        ${PYTHON_INCLUDE}
    )
endif()

# Exclude the 'lib' prefix from the name.
if(NOT OCIO_PYGLUE_LIB_PREFIX)
    set_property(TARGET PyOpenColorIO
        PROPERTY PREFIX ""
    )
endif()

target_link_OCIO(PyOpenColorIO)

if(WIN32)
    # Python extension on Windows is pyd
    set_target_properties(PyOpenColorIO PROPERTIES SUFFIX ".pyd")
endif()

if(OCIO_PYGLUE_LINK OR WIN32)
    # Windows always need the python library, 
    #  refer to https://docs.python.org/3/extending/windows.html#a-cookbook-approach
    message(STATUS "Linking python bindings against: ${PYTHON_LIBRARY}")
    message(STATUS "Python library dirs: ${PYTHON_LIBRARY_DIRS}")
    link_directories(${PYTHON_LIBRARY})
    target_link_libraries(PyOpenColorIO ${PYTHON_LIBRARIES})
endif()

# PyOpenColorIO so serves dual roles:
# - First, to provide the C API function necessary to act as a cpython module, 
#   (extern "C" PyMODINIT_FUNC initPyOpenColorIO(void)
# - Second, to act as a normal shared library, providing the C++ API functions 
#   to convert between C++ and python representation of the OCIO object.
#
# To fulfill this second role, as a shared libary, we must continue to define
# so version.
#
# TODO: This wont let the normal shared library symbols work on OSX.
# We should explore whether this should be built as a normal dylib, instead
# of as a bundle. See https://github.com/imageworks/OpenColorIO/pull/175

if(OCIO_PYGLUE_SONAME)
    message(STATUS "Setting PyOCIO SOVERSION to: ${SOVERSION}")
    set_target_properties(PyOpenColorIO PROPERTIES
        VERSION ${OCIO_VERSION}
        SOVERSION ${SOVERSION}
    )
endif()

if(APPLE)
    set_target_properties(PyOpenColorIO PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
endif()

add_subdirectory(tests)

message("PYTHON_VARIANT_PATH: ${PYTHON_VARIANT_PATH}")

install(TARGETS PyOpenColorIO EXPORT OpenColorIO DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/${PYTHON_VARIANT_PATH})

install(FILES ${CMAKE_SOURCE_DIR}/export/PyOpenColorIO/PyOpenColorIO.h
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/PyOpenColorIO/)

=== src/rv/Makefile ===
.phony:
all: ociorv.zip

ociorv.zip:
	mkdir -p Packages
	zip Packages/ociorv.zip Python/ociorv.py Python/PACKAGE

=== src/apps/ocioconvert/CMakeLists.txt ===
if (OIIO_FOUND)
    include_directories(
        ${CMAKE_SOURCE_DIR}/export/
        ${CMAKE_BINARY_DIR}/export/
        ${CMAKE_SOURCE_DIR}/src/apps/share/
        ${OIIO_INCLUDES}
        ${ILMBASE_INCLUDES}
    )
    
    file(GLOB_RECURSE share_src_files "${CMAKE_SOURCE_DIR}/src/apps/share/*.cpp")
    
    add_executable(ocioconvert ${share_src_files} main.cpp)
    
    set_target_properties(ocioconvert PROPERTIES COMPILE_FLAGS -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})

    target_link_libraries(ocioconvert ${OIIO_LIBRARIES} ${CMAKE_DL_LIBS})
    
    target_link_OCIO(ocioconvert)
    
    install(TARGETS ocioconvert EXPORT OpenColorIO DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/bin)
endif()

=== src/apps/ociodisplay/CMakeLists.txt ===
if (OIIO_FOUND)
    include_directories(
        ${CMAKE_SOURCE_DIR}/export/
        ${CMAKE_BINARY_DIR}/export/
        ${OPENGL_INCLUDE_DIR}
        ${OIIO_INCLUDES}
        ${ILMBASE_INCLUDES}
        ${GLEW_INCLUDES}
    	${GLUT_INCLUDE_DIR}
    )

    add_executable(ociodisplay main.cpp)

    # set_target_properties(ociodisplay PROPERTIES INSTALL_RPATH ${OIIO_LIBRARIES} )
    set_target_properties(ociodisplay PROPERTIES COMPILE_FLAGS -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
    target_link_libraries(ociodisplay ${GLEW_LIBRARIES} ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${OIIO_LIBRARIES})
    target_link_OCIO(ociodisplay)

    install(TARGETS ociodisplay EXPORT OpenColorIO DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/bin)
endif()

=== src/apps/ociolutimage/CMakeLists.txt ===
if (OIIO_FOUND)
    include_directories(
        ${CMAKE_SOURCE_DIR}/export/
        ${CMAKE_BINARY_DIR}/export/
        ${CMAKE_SOURCE_DIR}/src/apps/share/
        ${OIIO_INCLUDES}
        ${ILMBASE_INCLUDES}
    )
    
    file(GLOB_RECURSE share_src_files "${CMAKE_SOURCE_DIR}/src/apps/share/*.cpp")
    
    add_executable(ociolutimage ${share_src_files} main.cpp)
    
    set_target_properties(ociolutimage PROPERTIES COMPILE_FLAGS -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})

    target_link_libraries(ociolutimage ${OIIO_LIBRARIES} ${CMAKE_DL_LIBS})
    
    target_link_OCIO(ociolutimage)
    
    install(TARGETS ociolutimage EXPORT OpenColorIO DESTINATION ${CMAKE_INSTALL_EXEC_PREFIX}/bin)
endif()

=== src/jniglue/tests/CMakeLists.txt ===

###############################################################################
### JNI JUNIT TESTS ###

file(GLOB _TESTS_FILES "org/OpenColorIO/*.java")
set(_JCLASS_PATH "${CMAKE_CURRENT_BINARY_DIR}:${CMAKE_CURRENT_BINARY_DIR}/..:${CMAKE_SOURCE_DIR}/ext/junit-4.9b4.jar")
set(_JLIB_PATH "${CMAKE_CURRENT_BINARY_DIR}/..")

add_custom_target(JNITests
                  COMMAND javac -cp ${_JCLASS_PATH}
                    -d ${CMAKE_CURRENT_BINARY_DIR} ${_TESTS_FILES}
                  COMMAND java -cp ${_JCLASS_PATH}
                    -Djava.library.path=${_JLIB_PATH} junit.textui.TestRunner
                    OpenColorIOTestSuite
                  DEPENDS OpenColorIO-JNI
                  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                  COMMENT "Setting Up and Running JNI OCIO JUNIT tests")

add_test(jniglue "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target JNITests)

=== debian/changelog ===
opencolorio (1.1.1~dfsg0-7.1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 17 Jan 2022 12:45:23 +0000

opencolorio (1.1.1~dfsg0-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport parts of upstream commit 2f87cca2e129471f57df0c3a8a3adc0c73a4811c
    to use the proper variables in a debug function (fixing the build with
    GCC 11); patch 0001-Adsk-Contrib-Fix-macos-issues-973.patch.
    (Closes: #984276)
  * Backport parts of upstream commit 7575d9cb0f514a43a4a8b107793914589ae5ac9a
    to support yaml-cpp >= 0.7.0; patch
    0001-Adsk-Contrib-Fix-the-display-order-issue-883.patch
    - bump the libyaml-cpp-dev build dependency to >= 0.6.3 accordingly
  * Add the tex-gyre indep build dependency, as it provides tgtermes.sty
    (needed to build the documentation).

 -- Pino Toscano <pino@debian.org>  Fri, 24 Dec 2021 11:33:28 +0100

opencolorio (1.1.1~dfsg0-7) unstable; urgency=medium

  * debian/control:
    - debhelper bump 12 -> 13
    - S-V bump 4.5.0 -> 4.5.1 (no changes needed)
    - missing build-dep libopenexr-dev added (Closes: #976566)
  * debian/watch: version bump 3 -> 4
  * debian/rules: drop useless script
  * debian/libopencolorio-dev.install: install cmake helpers

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 17 Dec 2020 23:58:56 +0100

opencolorio (1.1.1~dfsg0-6) unstable; urgency=medium

  * debian/python3-pyopencolorio.install: drop version-specific
    python path (Closes: #949917)
  * debian/control: S-V bump 4.4.1 -> 4.5.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 27 Feb 2020 09:51:52 +0100

opencolorio (1.1.1~dfsg0-5) unstable; urgency=medium

  * debian/rules: pyclean -> py3clean

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 07 Dec 2019 14:31:30 +0100

opencolorio (1.1.1~dfsg0-4) unstable; urgency=medium

  * debian/: py2 -> py3 migration (Closes: #937196)
  * debian/compat: dropped due to debhelper 12
  * debian/control: S-V bump 4.4.0 -> 4.4.1 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 05 Dec 2019 17:39:54 +0100

opencolorio (1.1.1~dfsg0-3) unstable; urgency=medium

  * debian/control:
    - S-V bump 4.3.0 -> 4.4.0 (no changes needed)
    - switch to texlive-plain-generic as b-dep (Closes: #933289)

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 05 Aug 2019 22:52:38 +0200

opencolorio (1.1.1~dfsg0-2) unstable; urgency=medium

  * Upload to unstable

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 08 Jul 2019 15:16:46 +0200

opencolorio (1.1.1~dfsg0-1) experimental; urgency=medium

  * New upstream release
    - debian/patches/: patchset updated
  * debian/: repacking method improved

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 09 Apr 2019 23:26:50 +0200

=== debian/control ===
Source: opencolorio
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Matteo F. Vescovi <mfv@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 junit4,
 libboost-dev,
 libglew-dev,
 liblcms2-dev,
 libopenexr-dev,
 libopenimageio-dev (>= 2.0.0) <!pkg.opencolorio.noopenimageio>,
 libqt5opengl5-dev,
 libtinyxml-dev,
 libyaml-cpp-dev (>= 0.6.3~),
 pkg-config,
 python3-dev,
 python3-docutils,
 python3-jinja2,
 python3-pygments,
 python3-setuptools,
 python3-sphinx
Build-Depends-Indep:
 texlive-fonts-recommended,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-plain-generic,
 tex-gyre
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://opencolorio.org
Vcs-Git: https://salsa.debian.org/debian-phototools-team/opencolorio.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/opencolorio

Package: libopencolorio-dev
Section: libdevel
Architecture: any
Depends: libopencolorio1v5 (= ${binary:Version}),
         ${misc:Depends}
Description: complete color management solution - development
 OpenColorIO (OCIO) is a complete color management solution geared
 towards motion picture production with an emphasis on visual effects
 and computer animation. OCIO provides a straightforward and consistent
 user experience across all supporting applications while allowing for
 sophisticated back-end configuration options suitable for high-end
 production usage. OCIO is compatible with the Academy Color Encoding
 Specification (ACES) and is LUT-format agnostic, supporting many
 popular formats.
 .
 OpenColorIO is released as version 1.0 and has been in development
 since 2003. OCIO represents the culmination of years of production
 experience earned on such films as SpiderMan 2 (2004), Surf's Up
 (2007), Cloudy with a Chance of Meatballs (2009), Alice in Wonderland
 (2010), and many more. OpenColorIO is natively supported in commercial
 applications like Katana, Mari, Silhouette FX, and others coming soon.
 .
 OpenColorIO is free and is one of several open source projects
 actively sponsored by Sony Imageworks.
 .
 This package provides the development files used to build applications
 using libopencolorio.

Package: libopencolorio1v5
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libopencolorio1
Replaces: libopencolorio1
Description: complete color management solution - runtime
 OpenColorIO (OCIO) is a complete color management solution geared
 towards motion picture production with an emphasis on visual effects
 and computer animation. OCIO provides a straightforward and consistent
 user experience across all supporting applications while allowing for
 sophisticated back-end configuration options suitable for high-end
 production usage. OCIO is compatible with the Academy Color Encoding
 Specification (ACES) and is LUT-format agnostic, supporting many
 popular formats.
 .
 OpenColorIO is released as version 1.0 and has been in development
 since 2003. OCIO represents the culmination of years of production
 experience earned on such films as SpiderMan 2 (2004), Surf's Up
 (2007), Cloudy with a Chance of Meatballs (2009), Alice in Wonderland
 (2010), and many more. OpenColorIO is natively supported in commercial
 applications like Katana, Mari, Silhouette FX, and others coming soon.
 .
 OpenColorIO is free and is one of several open source projects
 actively sponsored by Sony Imageworks.
 .
 This package provides the runtime files used to run applications
 built against libopencolorio.

Package: opencolorio-tools
Section: utils
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: complete color management solution - utilities
 OpenColorIO (OCIO) is a complete color management solution geared
 towards motion picture production with an emphasis on visual effects
 and computer animation. OCIO provides a straightforward and consistent
 user experience across all supporting applications while allowing for
 sophisticated back-end configuration options suitable for high-end
 production usage. OCIO is compatible with the Academy Color Encoding
 Specification (ACES) and is LUT-format agnostic, supporting many
 popular formats.
 .
 OpenColorIO is released as version 1.0 and has been in development
 since 2003. OCIO represents the culmination of years of production
 experience earned on such films as SpiderMan 2 (2004), Surf's Up
 (2007), Cloudy with a Chance of Meatballs (2009), Alice in Wonderland
 (2010), and many more. OpenColorIO is natively supported in commercial
 applications like Katana, Mari, Silhouette FX, and others coming soon.
 .
 OpenColorIO is free and is one of several open source projects
 actively sponsored by Sony Imageworks.
 .
 This package provides some utilities.

Package: opencolorio-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-underscore,
         ${misc:Depends}
Description: complete color management solution - documentation
 OpenColorIO (OCIO) is a complete color management solution geared
 towards motion picture production with an emphasis on visual effects
 and computer animation. OCIO provides a straightforward and consistent
 user experience across all supporting applications while allowing for
 sophisticated back-end configuration options suitable for high-end
 production usage. OCIO is compatible with the Academy Color Encoding
 Specification (ACES) and is LUT-format agnostic, supporting many
 popular formats.
 .
 OpenColorIO is released as version 1.0 and has been in development
 since 2003. OCIO represents the culmination of years of production
 experience earned on such films as SpiderMan 2 (2004), Surf's Up
 (2007), Cloudy with a Chance of Meatballs (2009), Alice in Wonderland
 (2010), and many more. OpenColorIO is natively supported in commercial
 applications like Katana, Mari, Silhouette FX, and others coming soon.
 .
 OpenColorIO is free and is one of several open source projects
 actively sponsored by Sony Imageworks.
 .
 This package provides the documentation.

Package: python3-pyopencolorio
Section: python
Architecture: any
Depends: libopencolorio1v5 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: complete color management solution - Python bindings
 OpenColorIO (OCIO) is a complete color management solution geared
 towards motion picture production with an emphasis on visual effects
 and computer animation. OCIO provides a straightforward and consistent
 user experience across all supporting applications while allowing for
 sophisticated back-end configuration options suitable for high-end
 production usage. OCIO is compatible with the Academy Color Encoding
 Specification (ACES) and is LUT-format agnostic, supporting many
 popular formats.
 .
 OpenColorIO is released as version 1.0 and has been in development
 since 2003. OCIO represents the culmination of years of production
 experience earned on such films as SpiderMan 2 (2004), Surf's Up
 (2007), Cloudy with a Chance of Meatballs (2009), Alice in Wonderland
 (2010), and many more. OpenColorIO is natively supported in commercial
 applications like Katana, Mari, Silhouette FX, and others coming soon.
 .
 OpenColorIO is free and is one of several open source projects
 actively sponsored by Sony Imageworks.
 .
 This package provides Python bindings to the OpenColorIO library.

=== debian/rules ===
#!/usr/bin/make -f

CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
export REPACK_SH=$(CURDIR)/debian/repack.sh
BLDDIR = debian/cmake
INSTDIR = debian/tmp
PY3VERS = $(shell py3versions -dv)

%:
	dh $@ -Scmake -B$(BLDDIR) --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
		-DOCIO_BUILD_DOCS=ON \
		-DOCIO_BUILD_NUKE=OFF \
		-DOCIO_BUILD_STATIC=OFF \
		-DOCIO_BUILD_TESTS=OFF \
		-DOCIO_BUILD_TRUELIGHT=OFF \
		-DOCIO_USE_SSE=OFF \
		-DPYTHON=python$(PY3VERS) \
		-DUSE_EXTERNAL_TINYXML=ON \
		-DUSE_EXTERNAL_YAML=ON

override_dh_auto_install:
	dh_auto_install
	rm -f $(INSTDIR)/usr/share/doc/OpenColorIO/html/_sources/License.txt
	rm -f $(INSTDIR)/usr/share/doc/OpenColorIO/html/_static/jquery.js
	rm -f $(INSTDIR)/usr/share/doc/OpenColorIO/html/_static/underscore.js
	rm -f $(INSTDIR)/usr/share/ocio/setup_ocio.sh

override_dh_install:
	mv $(INSTDIR)/usr/share/doc/OpenColorIO $(INSTDIR)/usr/share/doc/opencolorio
	dh_install

override_dh_auto_clean:
	py3clean .
	dh_auto_clean

override_dh_auto_test:

=== debian/watch ===
version=4
opts="dversionmangle=s/\~dfsg.*//, \
repack, \
repacksuffix=~dfsg0" \
https://github.com/imageworks/OpenColorIO/tags .*/v(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))
